<?php
namespace kwy\third_interface;
/**
 * Created by PhpStorm.
 * User: roc
 * Date: 2019/12/6
 * Time: 13:39
 */


use kwy\util\http\CurlHttp;

/**
 * 因位传媒接口（广告）
 * Class Ad
 * @package kwy\third_interface
 */
class Ad
{
    private $channelId = "";    //线下分配媒体的渠道标识
    private $token = "";    //身份认证令牌;线下分配的令牌

    /**
     * @var CurlHttp
     */
    private $httpClient;

    /**
     * 设置线下分配媒体的渠道标识
     * @author roc
     * @param $channelId
     * @return $this
     */
    public function setChannelId($channelId){
        $this->channelId = $channelId;
        return $this;
    }

    /**
     * 获取线下分配媒体的渠道标识
     * @author roc
     * @return string
     */
    public function getChannelId(){
        return $this->channelId;
    }

    /**
     * 设置身份认证令牌
     * @author roc
     * @param $token
     * @return $this
     */
    public function setToken($token){
        $this->token = $token;
        return $this;
    }

    /**
     * 获取身份认证令牌
     * @author roc
     * @return string
     */
    public function getToken(){
        return $this->token;
    }

    public function getAd($playCode,$device,$udid,$network,$adSlot){
//        $url = "http://demo.oohlink.com/play/getAd";
        $url = "http://demo.oohlink.com/website/play/getAd";

        $data = [
            "playCode" => $playCode,    //播控器编码	唯一标识媒体屏的编码，与平台备案时一致,
            "requestId" => $this->getReqId(32), //广告请求标识	接入方自定义，发请求时填写，需要确保唯一性（要求32位字符串）
//            "positionId" => $positionId,    //媒体位标识
            "channelId" => $this->channelId,  //线下分配媒体的渠道标识
            "token" => $this->token,  //身份认证令牌;线下分配的令牌
            "device" => $device,    //MediaDevice	是	设备参数	见《MediaDevice(媒体设备信息)》
            "udid" => $udid,    //设备识别码	见《MediaNetwork(移动网络参数)》
            "network" => $network,  //移动网络参数	见《MediaUdId(媒体设备识别码)》
            "adSlot" => $adSlot,    //广告位参数	见《AdSlot(广告位参数)》
//            "ext" => [],    //扩展参数
        ];
        $request_data = [
            "rtbRequest" => json_encode($data)
        ];

        $response = $this->getHttpClient()
            ->setProxy('127.0.0.1:8888')
            ->setUrl($url)
            ->setContentType("multipart/form-data")
            ->post($request_data);

//        var_dump($response);
        echo $this->getHttpClient()->getLastRequestLog();
        return true;
//        $result = json_decode($response,true);
//        return $response;
    }


    private function getReqId($len=16){
        $chars = "abcdefghijklmnopqrstuvwxyz0123456789";
        $str ="";
        for ( $i = 0; $i < $len; $i++ )  {
            $str.= substr($chars, mt_rand(0, strlen($chars)-1), 1);
        }
        return $str;
    }


    private function getHttpClient(){
        if (empty($this->httpClient)){
            $this->httpClient = new CurlHttp();
            //$this->httpClient->setProxy('127.0.0.1:8888');
            $this->httpClient->setContentType('application/json');
        }
        return $this->httpClient;
    }
}